// check1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "check1.h"
#include "check1Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckMail1Dlg dialog

CCheckMail1Dlg::CCheckMail1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheckMail1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheckMail1Dlg)
	m_strPassword = _T("");
	m_strServerName = _T("");
	m_nServerPort = 100;
	m_nTimeout = 60;
	m_strUserName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCheckMail1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheckMail1Dlg)
	DDX_Control(pDX, IDC_INTERNETMAIL1, m_ctlInternetMail);
	DDX_Text(pDX, IDC_PASSWORD, m_strPassword);
	DDX_Text(pDX, IDC_SERVERNAME, m_strServerName);
	DDX_Text(pDX, IDC_SERVERPORT, m_nServerPort);
	DDX_Text(pDX, IDC_TIMEOUT, m_nTimeout);
	DDX_Text(pDX, IDC_USERNAME, m_strUserName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCheckMail1Dlg, CDialog)
	//{{AFX_MSG_MAP(CCheckMail1Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckMail1Dlg message handlers

BOOL CCheckMail1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCheckMail1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCheckMail1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCheckMail1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCheckMail1Dlg::OnOK() 
{
	UpdateData();

	COleVariant varServerName(m_strServerName);
	COleVariant varServerPort(m_nServerPort);
	COleVariant varUserName(m_strUserName);
	COleVariant varPassword(m_strPassword);
	COleVariant varTimeout(m_nTimeout);
	COleVariant varOptions;
	COleVariant varError;

	varError = m_ctlInternetMail.Connect(varServerName,
										 varServerPort,
										 varUserName,
										 varPassword,
										 varTimeout,
										 varOptions);
	
	if (V_I4(&varError) != 0)
	{
		CString strError;
		strError.Format(_T("Unable to connect to %s\n%s"),
						m_strServerName,
						m_ctlInternetMail.GetLastErrorString());

		AfxMessageBox(strError, MB_ICONEXCLAMATION, 0);
	}
	else
	{
		CString strMessage;
		LONG nMessages;
		
		nMessages = m_ctlInternetMail.GetMessageCount();
		strMessage.Format(_T("This mailbox has %ld messages"), nMessages);
		AfxMessageBox(strMessage, MB_ICONINFORMATION, 0);

		if (nMessages > 0)
		{
			COleVariant varMessageNumber(1L);
			varError = m_ctlInternetMail.GetMessage(varMessageNumber);

			if (V_I4(&varError) != 0)
			{
				CString strError;
				strError.Format(_T("Unable to retrieve message %d"), V_I4(&varMessageNumber));
				AfxMessageBox(strError, MB_ICONEXCLAMATION, 0);
			}
		}

		m_ctlInternetMail.Disconnect();
	}

	CDialog::OnOK();
}

BEGIN_EVENTSINK_MAP(CCheckMail1Dlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CCheckMail1Dlg)
	ON_EVENT(CCheckMail1Dlg, IDC_INTERNETMAIL1, 1 /* OnCancel */, OnCancelInternetMail1, VTS_NONE)
	ON_EVENT(CCheckMail1Dlg, IDC_INTERNETMAIL1, 2 /* OnDelivered */, OnDeliveredInternetMail1, VTS_VARIANT VTS_VARIANT)
	ON_EVENT(CCheckMail1Dlg, IDC_INTERNETMAIL1, 3 /* OnError */, OnErrorInternetMail1, VTS_VARIANT VTS_VARIANT)
	ON_EVENT(CCheckMail1Dlg, IDC_INTERNETMAIL1, 4 /* OnProgress */, OnProgressInternetMail1, VTS_VARIANT VTS_VARIANT VTS_VARIANT)
	ON_EVENT(CCheckMail1Dlg, IDC_INTERNETMAIL1, 5 /* OnRecipient */, OnRecipientInternetMail1, VTS_VARIANT VTS_PVARIANT)
	ON_EVENT(CCheckMail1Dlg, IDC_INTERNETMAIL1, 6 /* OnTimeout */, OnTimeoutInternetMail1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CCheckMail1Dlg::OnCancelInternetMail1() 
{
	// TODO: Add your control notification handler code here
	
}

void CCheckMail1Dlg::OnDeliveredInternetMail1(const VARIANT FAR& Address, const VARIANT FAR& MessageSize) 
{
	// TODO: Add your control notification handler code here
	
}

void CCheckMail1Dlg::OnErrorInternetMail1(const VARIANT FAR& Error, const VARIANT FAR& Description) 
{
	// TODO: Add your control notification handler code here
	
}

void CCheckMail1Dlg::OnProgressInternetMail1(const VARIANT FAR& MessageSize, const VARIANT FAR& MessageCopied, const VARIANT FAR& Percent) 
{
	LONG nMessageSize = V_I4(&MessageSize);
	LONG nMessageCopied = V_I4(&MessageCopied);
	SHORT nPercent = V_I2(&Percent);

	if (nPercent == 100)
	{
		CString strFinished;
		strFinished.Format(_T("Message size is %ld bytes"), nMessageCopied);
		AfxMessageBox(strFinished, MB_ICONINFORMATION, 0);
	}
}

void CCheckMail1Dlg::OnRecipientInternetMail1(const VARIANT FAR& Address, VARIANT FAR* Cancel) 
{
	// TODO: Add your control notification handler code here
	
}

void CCheckMail1Dlg::OnTimeoutInternetMail1() 
{
	// TODO: Add your control notification handler code here
	
}
