// check4Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "check4.h"
#include "check4Dlg.h"
#include "csimxkey.h"
#include "csimxctl_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheck4Dlg dialog

CCheck4Dlg::CCheck4Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheck4Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheck4Dlg)
	m_strPassword = _T("");
	m_strServerName = _T("");
	m_nServerPort = 110;
	m_nTimeout = 60;
	m_strUserName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pIInternetMail = NULL;
}

CCheck4Dlg::~CCheck4Dlg()
{
	if (m_pIInternetMail)
		m_pIInternetMail->Release();
}

void CCheck4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheck4Dlg)
	DDX_Text(pDX, IDC_PASSWORD, m_strPassword);
	DDX_Text(pDX, IDC_SERVERNAME, m_strServerName);
	DDX_Text(pDX, IDC_SERVERPORT, m_nServerPort);
	DDX_Text(pDX, IDC_TIMEOUT, m_nTimeout);
	DDX_Text(pDX, IDC_USERNAME, m_strUserName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCheck4Dlg, CDialog)
	//{{AFX_MSG_MAP(CCheck4Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheck4Dlg message handlers

BOOL CCheck4Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	HRESULT hr;
	BSTR bstrLicKey;
	IClassFactory2 *pFactory = NULL;
	IUnknown *pUnknown = NULL;
	USES_CONVERSION;

	m_pIInternetMail = NULL;

	hr = ::CoGetClassObject(CLSID_InternetMail, 
							CLSCTX_INPROC_SERVER,
							NULL,
							IID_IClassFactory2,
							(LPVOID *)&pFactory);

	if (FAILED(hr))
	{
		// Unable to get the class factory interface for the
		// control, probably because it isn't registered
		EndDialog(0);
		return FALSE;
	}

	// Create the runtime license key defined in csimxkey.h
	bstrLicKey = SysAllocString(T2OLE(CSIMXCTL_LICENSE_KEY));

	hr = pFactory->CreateInstanceLic(NULL, NULL, IID_IUnknown,
									 bstrLicKey,
									 (LPVOID *)&pUnknown);
	pFactory->Release();

	if (FAILED(hr))
	{
		// Unable to create an instance of the control using
		// the specified license key
		EndDialog(0);
		return FALSE;
	}

	hr = pUnknown->QueryInterface(IID_IInternetMail,
								  (LPVOID *)&m_pIInternetMail);

	if (FAILED(hr))
	{
		// Unable to get the interface to the control
		EndDialog(0);
		return FALSE;
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCheck4Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCheck4Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCheck4Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCheck4Dlg::OnOK() 
{
	UpdateData();

	COleVariant varServerName(m_strServerName);
	COleVariant varServerPort(m_nServerPort);
	COleVariant varUserName(m_strUserName);
	COleVariant varPassword(m_strPassword);
	COleVariant varTimeout(m_nTimeout);
	COleVariant varOptions;
	COleVariant varError;
	HRESULT hr;

	hr = m_pIInternetMail->Connect(varServerName,
								   varServerPort,
								   varUserName,
								   varPassword,
								   varTimeout,
								   varOptions,
								   &varError);
	
	if (V_I4(&varError) != 0)
	{
		CString strError;
		BSTR bstrError;
		USES_CONVERSION;

		hr = m_pIInternetMail->get_LastErrorString(&bstrError);
		if (FAILED(hr))
			return;

		strError.Format(_T("Unable to connect to %s\n%s"),
						m_strServerName,
						OLE2T(bstrError));

		AfxMessageBox(strError, MB_ICONEXCLAMATION, 0);
	}
	else
	{
		CString strMessage;
		LONG nMessages = 0;

		hr = m_pIInternetMail->get_MessageCount(&nMessages);
		if (FAILED(hr))
			return;
		
		m_pIInternetMail->Disconnect(&varError);
		
		strMessage.Format(_T("This mailbox has %ld messages"), nMessages);
		AfxMessageBox(strMessage, MB_ICONINFORMATION, 0);
	}

	CDialog::OnOK();
}
