Option Strict Off
Option Explicit On
Module modOptions
	' Catalyst Internet Mail Control 4.0
	' Copyright 2002, Catalyst Development Corporation
	' All rights reserved
	'
	' This product is licensed to you pursuant to the terms of the
	' Catalyst license agreement included with the original software,
	' and is protected by copyright law and international treaties.
	' Unauthorized reproduction or distribution may result in severe
	' criminal penalties.
	'
	
	Private Const KEY_PRODUCT As String = "Internet Mail Control Examples"
	
	Public g_strSenderName As String
	Public g_strSenderAddress As String
	Public g_strOrganization As String
	Public g_bRelayMessages As Boolean
	Public g_strRelayServer As String
	Public g_nRelayPort As Integer
	
	Sub LoadOptions()
		g_strSenderName = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderName")
		g_strSenderAddress = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderAddress")
		g_strOrganization = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "Organization")
		g_bRelayMessages = CBool(GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayMessages", "False"))
		g_strRelayServer = GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayServer")
		g_nRelayPort = CInt(GetSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayPort", "25"))
	End Sub
	
	Sub SaveOptions()
		SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderName", g_strSenderName)
		SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "SenderAddress", g_strSenderAddress)
		SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "Organization", g_strOrganization)
		SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayMessages", CStr(g_bRelayMessages))
		SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayServer", g_strRelayServer)
		SaveSetting(KEY_PRODUCT, System.Reflection.Assembly.GetExecutingAssembly.GetName.Name, "RelayPort", CStr(g_nRelayPort))
	End Sub
End Module