// check3Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "check3.h"
#include "check3Dlg.h"
#include "csimxkey.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheck3Dlg dialog

CCheck3Dlg::CCheck3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheck3Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheck3Dlg)
	m_strPassword = _T("");
	m_strServerName = _T("");
	m_nServerPort = 110;
	m_nTimeout = 60;
	m_strUserName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwEventSink = 0;
	m_pEventSink = NULL;
}

CCheck3Dlg::~CCheck3Dlg()
{
	if (m_pEventSink)
	{
		LPUNKNOWN pUnknownSink = m_pEventSink->GetIDispatch(FALSE);

		AfxConnectionUnadvise(m_pIInternetMail,
							  DIID__IInternetMailEvents,
							  pUnknownSink,
							  FALSE,
							  m_dwEventSink);

		delete m_pEventSink;
		m_pEventSink = NULL;
	}
}

void CCheck3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheck3Dlg)
	DDX_Text(pDX, IDC_PASSWORD, m_strPassword);
	DDX_Text(pDX, IDC_SERVERNAME, m_strServerName);
	DDX_Text(pDX, IDC_SERVERPORT, m_nServerPort);
	DDX_Text(pDX, IDC_TIMEOUT, m_nTimeout);
	DDX_Text(pDX, IDC_USERNAME, m_strUserName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCheck3Dlg, CDialog)
	//{{AFX_MSG_MAP(CCheck3Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheck3Dlg message handlers

BOOL CCheck3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	HRESULT hr;

	hr = m_pIInternetMail.CreateInstance(CLSID_InternetMail);
	if (FAILED(hr))
	{
		AfxMessageBox(_T("Control creation failed"), MB_ICONEXCLAMATION);
		EndDialog(0);
		return FALSE;
	}

	_variant_t varModule;
	_variant_t varLicKey;
	_variant_t varError;
	USES_CONVERSION;

	// Create the runtime license key
	varLicKey = SysAllocString(T2OLE(CSIMXCTL_LICENSE_KEY));
	
	// Initialize the control
	varError = m_pIInternetMail->Initialize(varModule, varLicKey);
	if (V_I4(&varError) != 0)
	{
		AfxMessageBox(_T("Control initialization failed"), MB_ICONEXCLAMATION);
		EndDialog(0);
		return FALSE;
	}

	// Create an instance of the event sink class
	m_pEventSink = new CEventSink();

	// Get a pointer to the sink IDispatch interface
	LPUNKNOWN pUnknownSink = m_pEventSink->GetIDispatch(FALSE);

	// Connect the event source to the sink
	BOOL bResult = AfxConnectionAdvise(m_pIInternetMail,
									   DIID__IInternetMailEvents,
									   pUnknownSink,
									   FALSE,
									   &m_dwEventSink);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCheck3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCheck3Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCheck3Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCheck3Dlg::OnOK() 
{
	UpdateData();

	_variant_t varServerName(m_strServerName);
	_variant_t varServerPort(m_nServerPort);
	_variant_t varUserName(m_strUserName);
	_variant_t varPassword(m_strPassword);
	_variant_t varTimeout(m_nTimeout);
	_variant_t varOptions;
	_variant_t varError;

	varError = m_pIInternetMail->Connect(varServerName,
										 varServerPort,
										 varUserName,
										 varPassword,
										 varTimeout,
										 varOptions);
	
	if (V_I4(&varError) != 0)
	{
		CString strError;
		USES_CONVERSION;

		strError.Format(_T("Unable to connect to %s\n%s"),
						m_strServerName,
						OLE2T(m_pIInternetMail->GetLastErrorString()));

		AfxMessageBox(strError, MB_ICONEXCLAMATION, 0);
	}
	else
	{
		CString strMessage;
		LONG nMessages;
		
		nMessages = m_pIInternetMail->MessageCount;
		if (nMessages > 0)
		{
			_variant_t varMessageNumber(1L);
			varError = m_pIInternetMail->GetMessage(varMessageNumber);
		}

		m_pIInternetMail->Disconnect();
		
		strMessage.Format(_T("This mailbox has %ld messages"), nMessages);
		AfxMessageBox(strMessage, MB_ICONINFORMATION, 0);
	}

	CDialog::OnOK();
}
